MODULE GETDATA_RAIN_ICE_OLD_MOD

USE OMP_LIB
USE MODD_RAIN_ICE_PARAM_n, ONLY : RAIN_ICE_PARAMN

USE ISO_FORTRAN_ENV, ONLY: OUTPUT_UNIT

INTERFACE SET
  MODULE PROCEDURE SET2
  MODULE PROCEDURE SET3
  MODULE PROCEDURE SET4
  MODULE PROCEDURE SETL
END INTERFACE

INTERFACE NPROMIZE
  MODULE PROCEDURE NPROMIZE2
  MODULE PROCEDURE NPROMIZE3
  MODULE PROCEDURE NPROMIZE4
END INTERFACE

CONTAINS

SUBROUTINE GETDATA_RAIN_ICE_OLD(NPROMA, NBLOCKS, NFLEVG, KRR,             &
                                OSEDIC, OCND2, LKOGAN, LMODICEDEP, OWARM, &
                                KKA, KKU, KKL, KSPLITR,                   &
                                PTSTEP, CSEDIM, CSUBG_AUCV_RC,           &
                                PDZZ_B, PRHODJ_B, PRHODREF_B,             &
                                PEXNREF_B, PPABSM_B,                      &
                                PCIT_B, PCIT_OUT_B,                       &
                                PCLDFR_B,                                 &
                                PICLDFR_B, PSSIO_B, PSSIU_B, PIFR_B,      &
                                PTHT_B, PRT_B, PTHS_B, PTHS_OUT_B,        &
                                PRS_B, PRS_OUT_B,                         &
                                PSIGS_B, PSEA_B, PTOWN_B,                 &
                                ZINPRC_B, ZINPRC_OUT_B,                   &
                                PINPRR_B, PINPRR_OUT_B,                   &
                                PEVAP_B, PEVAP_OUT_B,                     &
                                PINPRS_B, PINPRS_OUT_B,                   &
                                PINPRG_B, PINPRG_OUT_B,                   &
                                PINPRH_B, PINPRH_OUT_B,                   &
                                PICENU_B, PKGN_ACON_B, PKGN_SBGR_B,       &
                                PFPR_B, PFPR_OUT_B, ODMICRO, LDVERBOSE)

  USE IEEE_ARITHMETIC, ONLY : IEEE_SIGNALING_NAN, IEEE_VALUE

  IMPLICIT NONE


  INTEGER      :: KLON
  INTEGER      :: KIDIA
  INTEGER      :: KLEV

  LOGICAL, INTENT(IN) :: LDVERBOSE

  INTEGER, INTENT(OUT) :: NPROMA, NBLOCKS, NFLEVG, KRR
  LOGICAL, INTENT(OUT) :: OSEDIC, OCND2, LKOGAN, LMODICEDEP, OWARM
  INTEGER, INTENT(OUT) :: KKA, KKU, KKL, KSPLITR
  REAL,    INTENT(OUT) :: PTSTEP

  CHARACTER(LEN=4), INTENT(OUT) :: CSEDIM
  CHARACTER(LEN=4), INTENT(OUT) :: CSUBG_AUCV_RC

  REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PDZZ_B
  REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PRHODJ_B
  REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PRHODREF_B
  REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PEXNREF_B
  REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PPABSM_B
  REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PCIT_B, PCIT_OUT_B
  REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PCLDFR_B

  REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PICLDFR_B
  REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PSSIO_B
  REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PSSIU_B
  REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PIFR_B

  REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PTHT_B
  REAL, ALLOCATABLE, DIMENSION(:,:,:,:), INTENT(OUT) :: PRT_B
  REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PTHS_B, PTHS_OUT_B
  REAL, ALLOCATABLE, DIMENSION(:,:,:,:), INTENT(OUT) :: PRS_B,  PRS_OUT_B

  REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: ZINPRC_B, ZINPRC_OUT_B
  REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PINPRR_B, PINPRR_OUT_B
  REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PEVAP_B,  PEVAP_OUT_B
  REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PINPRS_B, PINPRS_OUT_B
  REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PINPRG_B, PINPRG_OUT_B
  REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PINPRH_B, PINPRH_OUT_B

  REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PSIGS_B
  REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PSEA_B
  REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PTOWN_B

  REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PICENU_B
  REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PKGN_ACON_B
  REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PKGN_SBGR_B

  REAL, ALLOCATABLE, DIMENSION(:,:,:,:), INTENT(OUT) :: PFPR_B, PFPR_OUT_B

  LOGICAL, ALLOCATABLE, DIMENSION(:,:,:), INTENT(OUT) :: ODMICRO


  REAL, ALLOCATABLE, DIMENSION(:,:,:)   :: PDZZ
  REAL, ALLOCATABLE, DIMENSION(:,:,:)   :: PRHODJ
  REAL, ALLOCATABLE, DIMENSION(:,:,:)   :: PRHODREF
  REAL, ALLOCATABLE, DIMENSION(:,:,:)   :: PEXNREF
  REAL, ALLOCATABLE, DIMENSION(:,:,:)   :: PPABSM
  REAL, ALLOCATABLE, DIMENSION(:,:,:)   :: PCIT, PCIT_OUT
  REAL, ALLOCATABLE, DIMENSION(:,:,:)   :: PCLDFR

  REAL, ALLOCATABLE, DIMENSION(:,:,:)   :: PICLDFR
  REAL, ALLOCATABLE, DIMENSION(:,:,:)   :: PSSIO
  REAL, ALLOCATABLE, DIMENSION(:,:,:)   :: PSSIU
  REAL, ALLOCATABLE, DIMENSION(:,:,:)   :: PIFR

  REAL, ALLOCATABLE, DIMENSION(:,:,:)   :: PTHT
  REAL, ALLOCATABLE, DIMENSION(:,:,:,:) :: PRT
  REAL, ALLOCATABLE, DIMENSION(:,:,:)   :: PTHS, PTHS_OUT
  REAL, ALLOCATABLE, DIMENSION(:,:,:,:) :: PRS,  PRS_OUT

  REAL, ALLOCATABLE, DIMENSION(:,:,:)   :: PSIGS
  REAL, ALLOCATABLE, DIMENSION(:,:)     :: PSEA
  REAL, ALLOCATABLE, DIMENSION(:,:)     :: PTOWN

  REAL, ALLOCATABLE, DIMENSION(:,:)     :: PICENU
  REAL, ALLOCATABLE, DIMENSION(:,:)     :: PKGN_ACON
  REAL, ALLOCATABLE, DIMENSION(:,:)     :: PKGN_SBGR

  REAL, ALLOCATABLE, DIMENSION(:,:)     :: ZINPRC_OUT
  REAL, ALLOCATABLE, DIMENSION(:,:)     :: PINPRR_OUT
  REAL, ALLOCATABLE, DIMENSION(:,:,:)   :: PEVAP_OUT
  REAL, ALLOCATABLE, DIMENSION(:,:)     :: PINPRS_OUT
  REAL, ALLOCATABLE, DIMENSION(:,:)     :: PINPRG_OUT

  REAL, ALLOCATABLE, DIMENSION(:,:,:,:) :: PFPR_OUT

  REAL, ALLOCATABLE, DIMENSION(:,:)     :: PINPRH_OUT

  INTEGER :: IFILE, NFILES
  INTEGER :: NGPTOT, i, j

  INTEGER :: IBL, IBLOCK
  LOGICAL :: LLEXIST, LSPP
  CHARACTER(LEN=32) :: CLFILE
  REAL :: ZNAN

  KRR=6
  NGPTOT = NPROMA * NBLOCKS
  IBL = 1

  WRITE (CLFILE, '("data/",I8.8,".dat")') IBL
  OPEN (NEWUNIT=IFILE, FILE=TRIM(CLFILE), FORM='UNFORMATTED', POSITION='REWIND')

  READ (IFILE) KLON
  READ (IFILE) KLEV
  READ (IFILE) KRR

  CLOSE (IFILE)

  write(output_unit, *) 'klon:        ', klon
  write(output_unit, *) 'klev:        ', klev
  write(output_unit, *) 'krr:         ', krr

  IF (NFLEVG < 0) NFLEVG = KLEV

  ALLOCATE (PDZZ_B          (NPROMA, NFLEVG, NBLOCKS))
  ALLOCATE (PRHODJ_B        (NPROMA, NFLEVG, NBLOCKS))
  ALLOCATE (PRHODREF_B      (NPROMA, NFLEVG, NBLOCKS))
  ALLOCATE (PEXNREF_B       (NPROMA, NFLEVG, NBLOCKS))
  ALLOCATE (PPABSM_B        (NPROMA, NFLEVG, NBLOCKS))
  ALLOCATE (PCIT_B          (NPROMA, NFLEVG, NBLOCKS))
  ALLOCATE (PCIT_OUT_B      (NPROMA, NFLEVG, NBLOCKS))
  ALLOCATE (PCLDFR_B        (NPROMA, NFLEVG, NBLOCKS))

  ALLOCATE (PICLDFR_B       (NPROMA, NFLEVG, NBLOCKS))
  ALLOCATE (PSSIO_B         (NPROMA, NFLEVG, NBLOCKS))
  ALLOCATE (PSSIU_B         (NPROMA, NFLEVG, NBLOCKS))
  ALLOCATE (PIFR_B          (NPROMA, NFLEVG, NBLOCKS))

  ALLOCATE (PTHT_B          (NPROMA, NFLEVG, NBLOCKS))
  ALLOCATE (PRT_B           (NPROMA, NFLEVG, KRR, NBLOCKS))
  ALLOCATE (PTHS_B          (NPROMA, NFLEVG, NBLOCKS))
  ALLOCATE (PTHS_OUT_B      (NPROMA, NFLEVG, NBLOCKS))
  ALLOCATE (PRS_B           (NPROMA, NFLEVG, KRR, NBLOCKS))
  ALLOCATE (PRS_OUT_B       (NPROMA, NFLEVG, KRR, NBLOCKS))

  ALLOCATE (ZINPRC_B        (NPROMA, NBLOCKS))
  ALLOCATE (ZINPRC_OUT_B    (NPROMA, NBLOCKS))
  ALLOCATE (PINPRR_B        (NPROMA, NBLOCKS))
  ALLOCATE (PINPRR_OUT_B    (NPROMA, NBLOCKS))
  ALLOCATE (PEVAP_B         (NPROMA, NFLEVG, NBLOCKS))
  ALLOCATE (PEVAP_OUT_B     (NPROMA, NFLEVG, NBLOCKS))
  ALLOCATE (PINPRS_B        (NPROMA, NBLOCKS))
  ALLOCATE (PINPRS_OUT_B    (NPROMA, NBLOCKS))
  ALLOCATE (PINPRG_B        (NPROMA, NBLOCKS))
  ALLOCATE (PINPRG_OUT_B    (NPROMA, NBLOCKS))

  ALLOCATE (PSIGS_B         (NPROMA, NFLEVG, NBLOCKS))
  ALLOCATE (PSEA_B          (NPROMA, NBLOCKS))
  ALLOCATE (PTOWN_B         (NPROMA, NBLOCKS))

  ALLOCATE (PICENU_B        (NPROMA, NBLOCKS))
  ALLOCATE (PKGN_ACON_B     (NPROMA, NBLOCKS))
  ALLOCATE (PKGN_SBGR_B     (NPROMA, NBLOCKS))

  ALLOCATE (PFPR_B          (NPROMA, NFLEVG, KRR, NBLOCKS))
  ALLOCATE (PFPR_OUT_B      (NPROMA, NFLEVG, KRR, NBLOCKS))

  IF (KRR .EQ. 7) THEN
    ALLOCATE (PINPRH_B      (NPROMA, NBLOCKS))
    ALLOCATE (PINPRH_OUT_B  (NPROMA, NBLOCKS))
  ENDIF

  ALLOCATE (ODMICRO      (NPROMA, NFLEVG, NBLOCKS))

  ZNAN = IEEE_VALUE (ZNAN, IEEE_SIGNALING_NAN)


  CALL SET (PDZZ_B)
  CALL SET (PRHODJ_B)
  CALL SET (PRHODREF_B)
  CALL SET (PEXNREF_B)
  CALL SET (PPABSM_B)
  CALL SET (PCIT_B)
  CALL SET (PCIT_OUT_B)
  CALL SET (PCLDFR_B)

  CALL SET (PICLDFR_B)
  CALL SET (PSSIO_B)
  CALL SET (PSSIU_B)
  CALL SET (PIFR_B)

  CALL SET (PTHT_B)
  CALL SET (PRT_B)
  CALL SET (PTHS_B)
  CALL SET (PTHS_OUT_B)
  CALL SET (PRS_B)
  CALL SET (PRS_OUT_B)

  CALL SET (ZINPRC_B)
  CALL SET (ZINPRC_OUT_B)
  CALL SET (PINPRR_B)
  CALL SET (PINPRR_OUT_B)
  CALL SET (PEVAP_B)
  CALL SET (PEVAP_OUT_B)
  CALL SET (PINPRS_B)
  CALL SET (PINPRS_OUT_B)
  CALL SET (PINPRG_B)
  CALL SET (PINPRG_OUT_B)

  CALL SET (PSIGS_B)
  CALL SET (PSEA_B)
  CALL SET (PTOWN_B)

  CALL SET (PICENU_B)
  CALL SET (PKGN_ACON_B)
  CALL SET (PKGN_SBGR_B)

  CALL SET (PFPR_B)
  CALL SET (PFPR_OUT_B)

  IF (KRR .EQ. 7) THEN
    CALL SET(PINPRH_B)
    CALL SET(PINPRH_OUT_B)
  ENDIF

  CALL SET (ODMICRO)

  IBL = 0
  NFILES = 0
  LLEXIST = .TRUE.

  DO WHILE(LLEXIST)
    WRITE (CLFILE, '("data/",I8.8,".dat")') NFILES + 1

    INQUIRE(FILE=TRIM (CLFILE), EXIST=LLEXIST)

    IF (.NOT. LLEXIST) EXIT

    NFILES = NFILES + 1

  ENDDO

  ALLOCATE (PDZZ         (KLON, KLEV, NFILES))
  ALLOCATE (PRHODJ       (KLON, KLEV, NFILES))
  ALLOCATE (PRHODREF     (KLON, KLEV, NFILES))
  ALLOCATE (PEXNREF      (KLON, KLEV, NFILES))
  ALLOCATE (PPABSM       (KLON, KLEV, NFILES))
  ALLOCATE (PCIT         (KLON, KLEV, NFILES))
  ALLOCATE (PCLDFR       (KLON, KLEV, NFILES))

  ALLOCATE (PICLDFR      (KLON, KLEV, NFILES))
  ALLOCATE (PSSIO        (KLON, KLEV, NFILES))
  ALLOCATE (PSSIU        (KLON, KLEV, NFILES))
  ALLOCATE (PIFR         (KLON, KLEV, NFILES))

  ALLOCATE (PTHT         (KLON, KLEV, NFILES))
  ALLOCATE (PRT          (KLON, KLEV, KRR, NFILES))
  ALLOCATE (PTHS         (KLON, KLEV, NFILES))
  ALLOCATE (PRS          (KLON, KLEV, KRR, NFILES))

  ALLOCATE (PSIGS        (KLON, KLEV, NFILES))
  ALLOCATE (PSEA         (KLON, NFILES))
  ALLOCATE (PTOWN        (KLON, NFILES))

  ALLOCATE (PICENU       (KLON, NFILES))
  ALLOCATE (PKGN_ACON    (KLON, NFILES))
  ALLOCATE (PKGN_SBGR    (KLON, NFILES))

  ALLOCATE (PCIT_OUT     (KLON, KLEV, NFILES))
  ALLOCATE (PTHS_OUT     (KLON, KLEV, NFILES))
  ALLOCATE (PRS_OUT      (KLON, KLEV, KRR, NFILES))
  ALLOCATE (ZINPRC_OUT   (KLON, NFILES))
  ALLOCATE (PINPRR_OUT   (KLON, NFILES))
  ALLOCATE (PEVAP_OUT    (KLON, KLEV, NFILES))
  ALLOCATE (PINPRS_OUT   (KLON, NFILES))
  ALLOCATE (PINPRG_OUT   (KLON, NFILES))

  ALLOCATE (PFPR_OUT     (KLON, KLEV, KRR, NFILES))

  IF (KRR == 7) THEN
    ALLOCATE (PINPRH_OUT (KLON, NFILES))
  ENDIF

  PICENU = 1.d0
  PKGN_ACON = 10.d0
  PKGN_SBGR = 1.d0

  DO IBL = 1, NFILES

    WRITE (CLFILE, '("data/",I8.8,".dat")') IBL

    IF ((IBL-1)*KLON .GE. NBLOCKS*NPROMA) THEN
      EXIT
    ENDIF

    IF (LDVERBOSE) PRINT *, TRIM (CLFILE)

    OPEN(NEWUNIT=IFILE, FILE=TRIM (CLFILE), FORM='UNFORMATTED', POSITION='REWIND')

    READ (IFILE) KLON
    READ (IFILE) KLEV
    READ (IFILE) KRR

    READ (IFILE) KKA
    READ (IFILE) KKU
    READ (IFILE) KKL
    READ (IFILE) KSPLITR

    READ (IFILE) OSEDIC
    READ (IFILE) OCND2
    READ (IFILE) LKOGAN
    READ (IFILE) LMODICEDEP
    READ (IFILE) OWARM

    READ (IFILE) CSEDIM
    READ (IFILE) CSUBG_AUCV_RC

    READ (IFILE) PTSTEP

    READ (IFILE) PDZZ    (:, :, IBL)
    READ (IFILE) PRHODJ  (:, :, IBL)
    READ (IFILE) PRHODREF(:, :, IBL)
    READ (IFILE) PEXNREF (:, :, IBL)
    READ (IFILE) PPABSM  (:, :, IBL)
    READ (IFILE) PCIT    (:, :, IBL)
    READ (IFILE) PCLDFR  (:, :, IBL)

    READ (IFILE) PICLDFR (:, :, IBL)
    READ (IFILE) PSSIO   (:, :, IBL)
    READ (IFILE) PSSIU   (:, :, IBL)
    READ (IFILE) PIFR    (:, :, IBL)

    READ (IFILE) PTHT    (:, :, IBL)
    READ (IFILE) PRT     (:, :, :, IBL)
    READ (IFILE) PTHS    (:, :, IBL)
    READ (IFILE) PRS     (:, :, :, IBL)

    READ (IFILE) PSIGS   (:, :, IBL)
    READ (IFILE) PSEA    (:, IBL)
    READ (IFILE) PTOWN   (:, IBL)

    READ (IFILE) LSPP
    IF (LSPP) THEN
      READ (IFILE) PICENU (:, IBL)
    ENDIF

    READ (IFILE) LSPP
    IF (LSPP) THEN
      READ (IFILE) PKGN_ACON (:, IBL)
    ENDIF

    READ (IFILE) LSPP
    IF (LSPP) THEN
      READ (IFILE) PKGN_SBGR (:, IBL)
    ENDIF

    READ (IFILE) PCIT_OUT     (:, :, IBL)
    READ (IFILE) PTHS_OUT     (:, :, IBL)
    READ (IFILE) PRS_OUT      (:, :, :, IBL)
    READ (IFILE) ZINPRC_OUT   (:, IBL)
    READ (IFILE) PINPRR_OUT   (:, IBL)
    READ (IFILE) PEVAP_OUT    (:, :, IBL)
    READ (IFILE) PINPRS_OUT   (:, IBL)
    READ (IFILE) PINPRG_OUT   (:, IBL)

    READ (IFILE) PFPR_OUT     (:, :, :, IBL)

    IF (KRR == 7) THEN
      READ (IFILE) PINPRH_OUT (:, IBL)
    ENDIF

    CLOSE (IFILE)

  ENDDO

  CALL NPROMIZE(PDZZ,       PDZZ_B)
  CALL NPROMIZE(PRHODJ,     PRHODJ_B)
  CALL NPROMIZE(PRHODREF,   PRHODREF_B)
  CALL NPROMIZE(PEXNREF,    PEXNREF_B)
  CALL NPROMIZE(PPABSM,     PPABSM_B)
  CALL NPROMIZE(PCIT,       PCIT_B)
  CALL NPROMIZE(PCLDFR,     PCLDFR_B)

  CALL NPROMIZE(PICLDFR,    PICLDFR_B)
  CALL NPROMIZE(PSSIO,      PSSIO_B)  
  CALL NPROMIZE(PSSIU,      PSSIU_B)  
  CALL NPROMIZE(PIFR,       PIFR_B)   

  CALL NPROMIZE(PTHT,       PTHT_B)
  CALL NPROMIZE(PRT,        PRT_B)
  CALL NPROMIZE(PTHS,       PTHS_B)
  CALL NPROMIZE(PRS,        PRS_B)

  CALL NPROMIZE(PSIGS,      PSIGS_B)
  CALL NPROMIZE(PSEA,       PSEA_B)
  CALL NPROMIZE(PTOWN,      PTOWN_B)

  CALL NPROMIZE(PICENU,     PICENU_B)
  CALL NPROMIZE(PKGN_ACON,  PKGN_ACON_B)
  CALL NPROMIZE(PKGN_SBGR,  PKGN_SBGR_B)

  CALL NPROMIZE(PCIT_OUT,   PCIT_OUT_B)
  CALL NPROMIZE(PTHS_OUT,   PTHS_OUT_B)
  CALL NPROMIZE(PRS_OUT,    PRS_OUT_B)
  CALL NPROMIZE(ZINPRC_OUT, ZINPRC_OUT_B)
  CALL NPROMIZE(PINPRR_OUT, PINPRR_OUT_B)
  CALL NPROMIZE(PEVAP_OUT,  PEVAP_OUT_B)
  CALL NPROMIZE(PINPRS_OUT, PINPRS_OUT_B)
  CALL NPROMIZE(PINPRG_OUT, PINPRG_OUT_B)

  CALL NPROMIZE(PFPR_OUT,   PFPR_OUT_B)

  IF (KRR == 7) THEN
    CALL NPROMIZE(PINPRH_OUT, PINPRH_OUT_B)
  ENDIF


END SUBROUTINE GETDATA_RAIN_ICE_OLD


SUBROUTINE NPROMIZE2(P_IN, P_OUT)

  IMPLICIT NONE

  REAL, INTENT (IN)  :: P_IN(:,:)
  REAL, INTENT (OUT) :: P_OUT(:,:)

  INTEGER :: I_OUT, J_OUT, I_IN, J_IN

  INTEGER :: NPROMA, NLON, NBLOCKS
  INTEGER :: N_GP_IN, N_GP_OUT, INDEX_IN

  NLON    = SIZE(P_IN, 1)
  NPROMA  = SIZE(P_OUT, 1)

  NBLOCKS = SIZE(P_OUT, 2)

  N_GP_IN = SIZE(P_IN, 1)*SIZE(P_IN, 2)

  DO J_OUT = 1, NBLOCKS
    DO I_OUT = 1, NPROMA

      N_GP_OUT = (J_OUT-1)*NPROMA + I_OUT
      INDEX_IN = 1 + MODULO(N_GP_OUT - 1, N_GP_IN)

      J_IN = 1 + (INDEX_IN - 1)/NLON
      I_IN = INDEX_IN - (J_IN-1)*NLON

      P_OUT(I_OUT, J_OUT) = P_IN(I_IN, J_IN)

    ENDDO
  ENDDO

END SUBROUTINE NPROMIZE2


PURE SUBROUTINE NPROMIZE3(P_IN, P_OUT)

  IMPLICIT NONE

  REAL, INTENT (IN)  :: P_IN(:,:,:)
  REAL, INTENT (OUT) :: P_OUT(:,:,:)

  INTEGER :: I_OUT, K_OUT, I_IN, K_IN, J

  INTEGER :: NPROMA, NLON, NBLOCKS
  INTEGER :: N_GP_IN, N_GP_OUT, INDEX_IN

  INTEGER :: JLEVA, JLEVB
  REAL :: ZWA, ZWB, ZLEV

  NLON    = SIZE(P_IN, 1)
  NPROMA  = SIZE(P_OUT, 1)

  NBLOCKS = SIZE(P_OUT, 3)

  N_GP_IN = SIZE(P_IN, 1)*SIZE(P_IN, 3)

  IF (SIZE(P_IN, 2) == SIZE(P_OUT, 2)) THEN

    !Just copy the gridpoints if the same number of levels
    DO K_OUT = 1, NBLOCKS
      DO J = 1, SIZE(P_OUT, 2)
        DO I_OUT = 1, NPROMA
  
          N_GP_OUT = (K_OUT-1)*NPROMA + I_OUT
          INDEX_IN = 1 + MODULO(N_GP_OUT - 1, N_GP_IN)
  
          K_IN = 1 + (INDEX_IN - 1)/NLON
          I_IN = INDEX_IN - (K_IN-1)*NLON
  
          P_OUT(I_OUT, J, K_OUT) = P_IN(I_IN, J, K_IN)
  
        ENDDO
      ENDDO
    ENDDO

  ELSE

    !We have to interpolate between level
    DO K_OUT = 1, NBLOCKS
      DO J = 1, SIZE(P_OUT, 2)

        ZLEV = 1.0 + REAL(J-1)*REAL(SIZE(P_IN,2)-1)/REAL(SIZE(P_OUT,2)-1)
        JLEVB = MIN(CEILING(ZLEV), SIZE(P_IN,2))
        JLEVA = MAX(FLOOR(ZLEV), 1)

        IF (JLEVB == JLEVA) THEN
          ZWA = 1.
          ZWB = 0.
        ELSE
          ZWA = REAL(JLEVB) - ZLEV
          ZWB = ZLEV - REAL(JLEVA)
        ENDIF

        DO I_OUT = 1, NPROMA
  
          N_GP_OUT = (K_OUT-1)*NPROMA + I_OUT
          INDEX_IN = 1 + MODULO(N_GP_OUT - 1, N_GP_IN)
  
          K_IN = 1 + (INDEX_IN - 1)/NLON
          I_IN = INDEX_IN - (K_IN-1)*NLON
  
          P_OUT(I_OUT, J, K_OUT) = ZWA*P_IN(I_IN, JLEVA, K_IN) + &
                                   ZWB*P_IN(I_IN, JLEVB, K_IN)
  
        ENDDO
      ENDDO
    ENDDO

  ENDIF

END SUBROUTINE NPROMIZE3


PURE SUBROUTINE NPROMIZE4(P_IN, P_OUT)

  IMPLICIT NONE

  REAL, INTENT (IN)  :: P_IN(:,:,:,:)
  REAL, INTENT (OUT) :: P_OUT(:,:,:,:)

  INTEGER :: I_OUT, K_OUT, I_IN, K_IN, J1, J2

  INTEGER :: NPROMA, NLON, NBLOCKS
  INTEGER :: N_GP_IN, N_GP_OUT, INDEX_IN

  INTEGER :: JLEVA, JLEVB
  REAL :: ZWA, ZWB, ZLEV

  NLON    = SIZE(P_IN, 1)
  NPROMA  = SIZE(P_OUT, 1)

  NBLOCKS = SIZE(P_OUT, 4)

  N_GP_IN = SIZE(P_IN, 1)*SIZE(P_IN, 4)

  IF (SIZE(P_IN, 2) == SIZE(P_OUT, 2)) THEN

    DO K_OUT = 1, NBLOCKS
      DO J2 = 1, SIZE(P_OUT, 3)
        DO J1 = 1, SIZE(P_OUT, 2)
          DO I_OUT = 1, NPROMA
  
            N_GP_OUT = (K_OUT-1)*NPROMA + I_OUT
            INDEX_IN = 1 + MODULO(N_GP_OUT - 1, N_GP_IN)
  
            K_IN = 1 + (INDEX_IN - 1)/NLON
            I_IN = INDEX_IN - (K_IN-1)*NLON
  
            P_OUT(I_OUT, J1, J2, K_OUT) = P_IN(I_IN, J1, J2, K_IN)
  
          ENDDO
        ENDDO
      ENDDO
    ENDDO

  ELSE

    !We have to interpolate between level
    DO K_OUT = 1, NBLOCKS
      DO J2 = 1, SIZE(P_OUT, 3)
        DO J1 = 1, SIZE(P_OUT, 2)

          ZLEV = 1.0 + REAL(J1-1)*REAL(SIZE(P_IN,2)-1)/REAL(SIZE(P_OUT,2)-1)
          JLEVB = MIN(CEILING(ZLEV), SIZE(P_IN,2))
          JLEVA = MAX(FLOOR(ZLEV), 1)

          IF (JLEVB == JLEVA) THEN
            ZWA = 1.
            ZWB = 0.
          ELSE
            ZWA = REAL(JLEVB) - ZLEV
            ZWB = ZLEV - REAL(JLEVA)
          ENDIF

          DO I_OUT = 1, NPROMA
  
            N_GP_OUT = (K_OUT-1)*NPROMA + I_OUT
            INDEX_IN = 1 + MODULO(N_GP_OUT - 1, N_GP_IN)
  
            K_IN = 1 + (INDEX_IN - 1)/NLON
            I_IN = INDEX_IN - (K_IN-1)*NLON
  
            P_OUT(I_OUT, J1, J2, K_OUT) = ZWA*P_IN(I_IN, JLEVA, J2, K_IN) + &
                                          ZWB*P_IN(I_IN, JLEVB, J2, K_IN)
  
          ENDDO
        ENDDO
      ENDDO
    ENDDO

  ENDIF

END SUBROUTINE NPROMIZE4


SUBROUTINE SET2(P)

  REAL, INTENT(INOUT) :: P (:,:)
  INTEGER :: IBL, IGPBLKS
  INTEGER :: NTID, ITID, JBLK1, JBLK2

  IGPBLKS = SIZE (P, 2)

!$OMP PARALLEL PRIVATE (ITID, JBLK1, JBLK2, NTID)
  NTID = OMP_GET_MAX_THREADS ()
  ITID = OMP_GET_THREAD_NUM ()
  JBLK1 = 1 +  (IGPBLKS * (ITID+0)) / NTID
  JBLK2 =      (IGPBLKS * (ITID+1)) / NTID

  DO IBL = JBLK1, JBLK2
    P (:,IBL) = ZNAN
  ENDDO
!$OMP END PARALLEL

END SUBROUTINE SET2

SUBROUTINE SET3 (P)

  REAL, INTENT(INOUT) :: P (:,:,:)
  INTEGER :: IBL, IGPBLKS
  INTEGER :: NTID, ITID, JBLK1, JBLK2

  IGPBLKS = SIZE (P, 3)

!$OMP PARALLEL PRIVATE (ITID, JBLK1, JBLK2, NTID)
  NTID = OMP_GET_MAX_THREADS ()
  ITID = OMP_GET_THREAD_NUM ()
  JBLK1 = 1 +  (IGPBLKS * (ITID+0)) / NTID
  JBLK2 =      (IGPBLKS * (ITID+1)) / NTID

  DO IBL = JBLK1, JBLK2
    P (:,:,IBL) = ZNAN
  ENDDO
!$OMP END PARALLEL

END SUBROUTINE SET3

SUBROUTINE SET4 (P)

  REAL, INTENT(INOUT) :: P (:,:,:,:)
  INTEGER :: IBL, IGPBLKS
  INTEGER :: NTID, ITID, JBLK1, JBLK2

  IGPBLKS = SIZE (P, 4)

!$OMP PARALLEL PRIVATE (ITID, JBLK1, JBLK2, NTID)
  NTID = OMP_GET_MAX_THREADS ()
  ITID = OMP_GET_THREAD_NUM ()
  JBLK1 = 1 +  (IGPBLKS * (ITID+0)) / NTID
  JBLK2 =      (IGPBLKS * (ITID+1)) / NTID

  DO IBL = JBLK1, JBLK2
    P (:,:,:,IBL) = ZNAN
  ENDDO
!$OMP END PARALLEL

END SUBROUTINE SET4

SUBROUTINE SETL (P)

  LOGICAL, INTENT(INOUT) :: P (:,:,:)
  INTEGER :: IBL, IGPBLKS
  INTEGER :: NTID, ITID, JBLK1, JBLK2

  IGPBLKS = SIZE (P, 3)

!$OMP PARALLEL PRIVATE (ITID, JBLK1, JBLK2, NTID)
  NTID = OMP_GET_MAX_THREADS ()
  ITID = OMP_GET_THREAD_NUM ()
  JBLK1 = 1 +  (IGPBLKS * (ITID+0)) / NTID
  JBLK2 =      (IGPBLKS * (ITID+1)) / NTID

  DO IBL = JBLK1, JBLK2
    P (:,:,IBL) = .FALSE.
  ENDDO
!$OMP END PARALLEL

END SUBROUTINE SETL

END  MODULE
